#ifndef TEXTURE_H
#define TEXTURE_H

#include <GL/glew.h>

#include "utils/PNGReader.h"

class Texture final {
public:
    Texture();
    ~Texture();
    Texture(const Texture& other) = delete;
    Texture(Texture&& other) = delete;
    Texture& operator=(const Texture& other) = delete;
    Texture& operator=(Texture&& other) = delete;
    
    void setColors(int width, int height, const char* data, int channels);
    
    void bind() const;

private:
    GLuint texture;
};

#endif